{$V+,B+,X+,T+,P+,H+,J+}

Library HookDll;
{----------------------------------------------------------------}
{ http://www.phidels.com                                         }
{----------------------------------------------------------------}
Uses SysUtils, Windows, Messages, Dialogs;

Type
  TDataEnvoyes = Packed Record
    Key: WPARAM;
    State: LPARAM
  End;
  TDonneesHook = Class
    HookHandle: HHook;
    HandleDest: THandle;
  End;

Var
  DonneesHook: TDonneesHook = Nil;
  HookMap: THandle = 0;


{----------------------------------------------------------------}
Function HookActionCallBack(Code: Integer; Wparam: WPARAM; Lparam: LPARAM): LRESULT; STDCALL;
Var
  DataEnvoyes: TDataEnvoyes;
  CopyDataStruct: TCopyDataStruct;
Begin
  Result := 0;
  If (Code = HC_ACTION) Then
    If (DonneesHook.HandleDest <> 0) Then
    Begin
      DataEnvoyes.Key := Wparam;
      DataEnvoyes.State := Lparam;
      CopyDataStruct.cbData := SizeOf(DataEnvoyes);
      CopyDataStruct.lpData := @DataEnvoyes;
      Result := SendMessage(DonneesHook.HandleDest, WM_COPYDATA, HInstance, LongInt(@CopyDataStruct));
    End;
  If (Code < 0) Then
    Result := CallNextHookEx(DonneesHook.HookHandle, Code, Wparam, Lparam);
End;


{----------------------------------------------------------------}
Function InitialisationHook(HandleDestData: HWnd): Boolean; STDCALL; EXPORT;
Begin
  Result := false;
  If (DonneesHook.HookHandle = 0) And (HandleDestData <> 0) Then
  Begin
    DonneesHook.HookHandle := SetWindowsHookEx(WH_KEYBOARD, HookActionCallBack, HInstance, 0);
    DonneesHook.HandleDest := HandleDestData;
    Result := DonneesHook.HookHandle <> 0;
  End;
End;


{----------------------------------------------------------------}
Procedure FinalisationHook; STDCALL; EXPORT;
Begin
  If (DonneesHook.HookHandle <> 0) Then
  Begin
    UnhookWindowsHookEx(DonneesHook.HookHandle);
    DonneesHook.HookHandle := 0;
  End;
End;


{----------------------------------------------------------------}
Procedure LibraryProc(AReason: Integer);
Begin
  Case AReason Of
    DLL_PROCESS_ATTACH:
      Begin
        HookMap := CreateFileMapping($FFFFFFFF, Nil, PAGE_READWRITE, 0, TDonneesHook.InstanceSize, 'Michel');
        DonneesHook := MapViewOfFile(HookMap, FILE_MAP_WRITE, 0, 0, 0);
      End;
    DLL_PROCESS_DETACH:
      Begin
        UnMapViewOfFile(DonneesHook);
        CloseHandle(HookMap);
      End;
    DLL_THREAD_ATTACH:
      Begin
      End;
    DLL_THREAD_DETACH:
      Begin
      End;
  End;
End;


{----------------------------------------------------------------}
Exports
  InitialisationHook,
  FinalisationHook;

Begin
  DllProc := addr(LibraryProc);
  LibraryProc(DLL_PROCESS_ATTACH);
End.

