Unit Unit1;
Interface
Uses Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls;

Const
  HookDll = 'HOOKDLL.DLL';

Type
  TProcCallBack = Procedure(Msg: Integer); STDCALL;
  TForm1 = Class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Procedure FormDestroy(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure OnWmCopyData(Var msg: TMessage); MESSAGE WM_COPYDATA;
    Procedure Button1Click(Sender: TObject);
  End;
  TKeyState = Record
    ExtendedKey, Alt, PrevPressed, Pressed: Boolean;
  End;

Var
  Form1: TForm1;
  MouseHookStruct: TMouseHookStruct;

Procedure FinalisationHook; STDCALL; EXTERNAL HookDll;
Function InitialisationHook(HandelDestData: HWnd): Boolean; STDCALL; EXTERNAL HookDll;
Function GetEtatTouche(from: Longint): TKeyState;


{----------------------------------------------------------------}
{                       }Implementation{                         }
{----------------------------------------------------------------}
{$R *.DFM}

Type
  TPDataEnvoyes = ^TDataEnvoyes;
  TDataEnvoyes = Packed Record
    Key: WPARAM;
    State: LPARAM
  End;

Var
  passkey, Keyreaded: Integer;
  Keypressed: Boolean;
  Permission: Boolean;


{----------------------------------------------------------------}
Function bit(bitnum: Integer; int: Longint): Boolean;
Begin
  Result := (int And (Cardinal(1) Shl (bitnum - 1))) > 0;
End;

{----------------------------------------------------------------}
Function GetEtatTouche(from: Longint): TKeyState;
Begin
  Result.Alt := bit(30, from);
  Result.ExtendedKey := bit(25, from);
  Result.PrevPressed := bit(31, from);
  Result.Pressed := Not bit(32, from);
End;


{----------------------------------------------------------------}
{ KEYBOARD INTERRUPT                                             }
{----------------------------------------------------------------}
Procedure TForm1.OnWmCopyData(Var msg: TMessage);

Type
  TPCopyDataStruct = ^TCopyDataStruct;
  TPDataEnvoyes = ^TDataEnvoyes;

Var
  DataEnvoyes: TDataEnvoyes;
  PDataEnvoyes: TPDataEnvoyes;
  PCopyDataStruct: TPCopyDataStruct;
  KeyState: TKeyState;

Begin
  PCopyDataStruct := TPCopyDataStruct(msg.LParam);
  PDataEnvoyes := PCopyDataStruct^.lpData;
  DataEnvoyes := PDataEnvoyes^;
  KeyState := GetEtatTouche(DataEnvoyes.State);
  PassKey := DataEnvoyes.State;
  Keypressed := KeyState.Pressed;
  KeyReaded := DataEnvoyes.Key;
  Permission := (Form1.Button1.Caption = 'Lock');
  msg.Result := 0;
  If (Keypressed) And Not (Permission) and  (KeyReaded = ord('T')) Then msg.Result := 1;
End;



{----------------------------------------------------------------}
{ FORM DESTROY                                                   }
{----------------------------------------------------------------}
Procedure TForm1.FormDestroy(Sender: TObject);
Begin
  FinalisationHook;
End;


{----------------------------------------------------------------}
{ FORM CREATE                                                    }
{----------------------------------------------------------------}
Procedure TForm1.FormCreate(Sender: TObject);
Begin
  FinalisationHook;
  If Not (InitialisationHook(Handle)) Then
  Begin
    ShowMessage('Erreur  la cration du Hook!');
    HALT;
  End;
  Permission := True;
End;
          

{----------------------------------------------------------------}
Procedure TForm1.Button1Click(Sender: TObject);
Begin
  If(Button1.Caption = 'UnLock') Then
    Button1.Caption := 'Lock' Else
    Button1.Caption := 'UnLock';
End;

{----------------------------------------------------------------}
End.

